<p id="notice"><%= notice %></p>
<!--GENERAR PDF
<%= link_to "Get PDF", analyses_path(format: :pdf) %>
-->

<img src="<%= current_patient.profilePicture.thumb.url %>">
</br>
<button class="sButton"><%= link_to 'Cerrar sesión', destroy_patient_session_path, method: :delete %></button>
<button class = "sButton"><%= link_to 'Mostrar perfil', current_patient%></button>

<div class="searches-container">
  <div id="reasonSearch" class="search-container activeSearch">
        <input type="text" id="myInput" placeholder="Buscar Asunto.." name="search">
        <button id="searchButton" class = "buttonSearch">Buscar</button>
        </br>
        </br>
        <div>
          <button id="clearSearch" class = "buttonSearch">Limpiar Busqueda</button>
          <button id="switchToDateSearch" class = "buttonSearch">Busqueda Por Fecha</button>
        </div>
  </div>
  <div id="dateSearch" class="search-container hidden">
        <input type="date" id="myDateInput" name="search">
        <button id="dateSearchButton" class = "buttonSearch">Buscar</button>
        </br>
        </br>
        <div>
          <button id="clearDateSearch" class = "buttonSearch">Limpiar Busqueda</button>
          <button id="switchToReasonSearch" class = "buttonSearch">Busqueda Por Asunto</button>
        </div>
  </div>
</div>
</br>
<button class = "buttonOption"><%= link_to "Generar historial médico completo", static_pages_path(format: :pdf) %></button>
<div id = "tabs-container">
  <ul id = "tabs">
    <button data-id = "all" class = "selectedButtonOption buttonOption">Todo</button>
    <button data-id = "consultations" class = "buttonOption">Consultas</button>
    <button data-id = "analyses" class = "buttonOption">Análisis</button>
    <button data-id = "comments" class = "buttonOption">Comentarios</button>
  </ul>
</div>
<div id = "all" class = "strong-options">
  <button class = "sButton"><%= link_to 'Nueva consulta', new_consultation_path%></button>
  <button class = "sButton"><%= link_to 'Nuevo análisis', new_analysis_path %></button>
  <button class = "sButton"><%= link_to 'Nuevo comentario', new_comment_path %></button>
  </br>
  </br>
  <table class = "grill activeTable">
    <thead>
      <tr>
        <th>Tipo</th>
        <th onclick="sortTable(1)">Fecha<div class="arrowContainer arrow-down"></div></th>
        <th>Asunto</th>
        <th colspan="3">Opciones</th>
      </tr>
    </thead>
    <tbody class = "noUnderlined">
      <% @consultations.each do |consultation| %>
        <tr>
          <td>Consulta</td>
          <td><%= consultation.date %></td>
          <td><%= consultation.reason %></td>
          <td><%= link_to 'Mostrar', consultation %></td>
          <td><%= link_to 'Editar', edit_consultation_path(consultation) %></td>
          <td><%= link_to 'Eliminar', consultation, method: :delete, data: { confirm: '¿Estás seguro?' } %></td>
        </tr>
      <% end %>
    </tbody>

    <tbody>
      <% @analyses.each do |analysis| %>
        <tr>
          <td>Análisis</td>
          <td><%= analysis.date %></td>
          <td><%= analysis.reason %></td>
          <td><%= link_to 'Mostrar', analysis %></td>
          <td><%= link_to 'Editar', edit_analysis_path(analysis) %></td>
          <td><%= link_to 'Eliminar', analysis, method: :delete, data: { confirm: '¿Estás seguro?' } %></td>
        </tr>
      <% end %>
    </tbody>
    <tbody>
      <% @comments.each do |comment| %>
        <tr>
          <td>Comentario</td>
          <td><%= comment.date %></td>
          <td><%= comment.reason %></td>
          <td><%= link_to 'Mostrar', comment %></td>
          <td><%= link_to 'Editar', edit_comment_path(comment) %></td>
          <td><%= link_to 'Eliminar', comment, method: :delete, data: { confirm: '¿Estás seguro?' } %></td>
        </tr>
      <% end %>
    </tbody>
    
  </table>
  
</div>
<div id = "consultations" class = "hidden">
  <button class = "sButton"><%= link_to 'Nueva consulta', new_consultation_path%></button>
  <table class = "grill">
      <thead>
        <tr>
          <th onclick="sortTable(0)">Fecha<div class="arrowContainer arrow-down"></div></th>
          <th>Asunto</th>
          <th colspan="3">Opciones</th>
        </tr>
      </thead>

      <tbody class = "noUnderlined ">
        <% @consultations.each do |consultation| %>
          <tr>
            <td><%= consultation.date %></td>
            <td><%= consultation.reason %></td>
            <td><%= link_to 'Mostrar', consultation %></td>
            <td><%= link_to 'Editar', edit_consultation_path(consultation) %></td>
            <td><%= link_to 'Eliminar', consultation, method: :delete, data: { confirm: '¿Estás seguro?' } %></td>
          </tr>
        <% end %>
      </tbody>
  </table>
  
</div>
<div id = "analyses" class = "hidden">
  <button class = "sButton"><%= link_to 'Nuevo análisis', new_analysis_path %></button>
  <table class = "grill">
    <thead>
      <tr>
        <th onclick="sortTable(0)">Fecha<div class="arrowContainer arrow-down"></div></th>
        <th>Asunto</th>
        <th colspan="3">Opciones</th>
      </tr>
    </thead>
    <tbody>
      <% @analyses.each do |analysis| %>
        <tr>
          <td><%= analysis.date %></td>
          <td><%= analysis.reason %></td>
          <td><%= link_to 'Mostrar', analysis %></td>
          <td><%= link_to 'Editar', edit_analysis_path(analysis) %></td>
          <td><%= link_to 'Elminar', analysis, method: :delete, data: { confirm: '¿Estás seguro?' } %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
  
</div>
<div id = "comments" class = "hidden">
  <button class = "sButton"><%= link_to 'Nuevo comentario', new_comment_path %></button>
  <table class = "grill">
    <thead>
      <tr>    
        <th onclick="sortTable(0)">Fecha<div class="arrowContainer arrow-down"></div></th>
        <th>Asunto</th>
        <th colspan="3">Opciones</th>
      </tr>
    </thead>

    <tbody>
      <% @comments.each do |comment| %>
        <tr>
          <td><%= comment.date %></td>
          <td><%= comment.reason %></td>
          <td><%= link_to 'Mostrar', comment %></td>
          <td><%= link_to 'Editar', edit_comment_path(comment) %></td>
          <td><%= link_to 'Eliminar', comment, method: :delete, data: { confirm: '¿Estás seguro?' } %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>


<script type = "text/javascript">
  function changeTab(event) {
      if(event.target.dataset.id) {          
          document.getElementById("myInput").value="";
          search();
          const pressed = event.target;
          const selected = document.querySelector(".selectedButtonOption");
          const selectedId = selected.dataset["id"];
          document.getElementById(selectedId).classList.add("hidden");
          const tableParent=document.getElementById(selectedId);
          const currentActiveTable=tableParent.getElementsByClassName("activeTable")[0];
          currentActiveTable.classList.remove("activeTable");
          selected.classList.remove("selectedButtonOption");
          pressed.classList.add("selectedButtonOption");
          const newSelectedId = pressed.dataset.id;
          document.getElementById(newSelectedId).classList.remove("hidden");
          const newTableParent=document.getElementById(newSelectedId);
          const newActiveTable=newTableParent.getElementsByClassName("grill")[0];
          newActiveTable.classList.add("activeTable");
      }
  }
  function search() {
  var input, filter, table, tr, td, i;
  let column;
  input = document.getElementById("myInput");
  filter = input.value.toUpperCase();
  table = document.querySelector(".activeTable");
  if(table.children.length===4){
    column=2;
  }
  else{
    column=1;
  }
  tr = table.getElementsByTagName("tr");
  for (i = 0; i < tr.length; i++) {
    td = tr[i].getElementsByTagName("td")[column];
    if (td) {
      if (td.innerHTML.toUpperCase().indexOf(filter) > -1) {
        tr[i].style.display = "";
      } else {
        tr[i].style.display = "none";
      }
    }       
  }
}
function clearSearch(){
  document.getElementById("myInput").value="";
  search();
}
function clearDateSearch(){
  let date=document.getElementById("myDateInput").value="";
  searchByDate();
}
  function searchByDate() {
  var input, filter, table, tr, td, i;
  let dateColumn;
  input = document.getElementById("myDateInput");
  filter = input.value.toUpperCase();
  table = document.querySelector(".activeTable");
  tr = table.getElementsByTagName("tr");
  if(table.children.length===4){
    dateColumn=1;
  }
  else{
    dateColumn=0;
  }
  for (i = 0; i < tr.length; i++) {
    td = tr[i].getElementsByTagName("td")[dateColumn];
    if (td) { 
              if (td.innerHTML.toUpperCase().indexOf(filter) > -1) {
                tr[i].style.display = "";
              } else {
                tr[i].style.display = "none";
              }
            }        
  }
}

function sortTable(n) {
  var table, rows, switching, i, x, y, shouldSwitch, dir, switchcount = 0;
  table = document.querySelector(".activeTable");
  const childArrow=table.getElementsByClassName("arrowContainer")[0];
  if(childArrow.classList.contains("arrow-down")){
        childArrow.classList.remove("arrow-down");
        childArrow.classList.add("arrow-up");
  }
  else{
        childArrow.classList.remove("arrow-up");
        childArrow.classList.add("arrow-down");
  }
  switching = true;
  dir = "asc"; 
  while (switching) {
    switching = false;
    rows = table.getElementsByTagName("TR");
    for (i = 1; i < (rows.length - 1); i++) {
      shouldSwitch = false;
      x = rows[i].getElementsByTagName("TD")[n];
      y = rows[i + 1].getElementsByTagName("TD")[n];
      if (dir == "asc") {
        if (x.innerHTML.toLowerCase() > y.innerHTML.toLowerCase()) {
          shouldSwitch= true;
          break;
        }
      } else if (dir == "desc") {
        if (x.innerHTML.toLowerCase() < y.innerHTML.toLowerCase()) {
          shouldSwitch = true;
          break;
        }
      }
    }
    if (shouldSwitch) {
      rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
      switching = true;
      switchcount ++;      
    } else {
      if (switchcount == 0 && dir == "asc") {
        dir = "desc";
        switching = true;
      }
    }
  }
}
function switchToReasonSearch(){
      const newSearch=document.querySelector("#reasonSearch");
      newSearch.classList.remove("hidden");
      const oldSearch=document.querySelector("#dateSearch");
      oldSearch.classList.add("hidden");
  }
function switchToDateSearch(){
      const newSearch=document.querySelector("#dateSearch");
      newSearch.classList.remove("hidden");
      const oldSearch=document.querySelector("#reasonSearch");
      oldSearch.classList.add("hidden");
  }
  function options() {
    if (event.keyCode === 13) {
        search();
    }
  }
  function eventHandlers() {
      const searchButton = document.querySelector("#searchButton");
      searchButton.addEventListener("click",search);
      const searchBox = document.querySelector("#myInput");
      searchBox.addEventListener("keypress",options);
      const chooserTab = document.querySelector("#tabs-container ul");
      chooserTab.addEventListener("click",changeTab);
      const dateSearchButton=document.querySelector("#dateSearchButton");
      dateSearchButton.addEventListener("click",searchByDate);
      const clearButton=document.querySelector("#clearSearch");
      clearButton.addEventListener("click",clearSearch);
      const clearDateButton=document.querySelector("#clearDateSearch");
      clearDateButton.addEventListener("click",clearDateSearch);
      const switchButtonToDate=document.querySelector("#switchToDateSearch");
      switchButtonToDate.addEventListener("click",switchToDateSearch);
      const switchButtonToReason=document.querySelector("#switchToReasonSearch");
      switchButtonToReason.addEventListener("click",switchToReasonSearch);
  }
  eventHandlers();
</script>

